//+------------------------------------------------------------------+
//|                                                       zscore.mq4 |
//|   mtf fx tsd  ki                                       modulatum |
//+------------------------------------------------------------------+
#property copyright "Mod"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DeepSkyBlue
#property indicator_level1 0
//---- input parameters
extern int  TimeFrame        = 0;
extern int       barsToCount = 2000;
extern string  TimeFrames  = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";

//---- buffers
double zscore[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,zscore);
//---- 
   IndicatorShortName("zscore ["+TimeFrame+"]");

  if (TimeFrame<Period())TimeFrame=Period();

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
limit= Bars-counted_bars;
limit= MathMax(limit,TimeFrame/Period());
limit= MathMin(limit,barsToCount);
   
//----
      for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 

//   for(int i = 0 ;i <= limit-20 ;i++)
//   {  
      
      zscore[i] = (iClose(NULL,TimeFrame,y)-iMA(NULL,TimeFrame,60,0,0,0,y))/iStdDev(NULL,TimeFrame,60,0,0,0,y);  
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+